#!/bin/sh
#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::#
# Make sure to go through below before you run the script:

# - The script is put under <root>/sample/inband_inventory_with_ffdc.sh
# - <root> is where OneCLI zip package is extracted to
# 
# This is a sample script of running OneCLI for full inventory data collection
# with FFDC collected as well on a supported Lenovo system with a supported
# Linux Operating System installed.
# (See "global.config" on how to do this for a supported IBM system)
#
# Results include inventory for supported platform hardware components,
# IO options, FFDC, Operating System level logs.
# Note, the time to finish this job may vary depending on the complexity of your hardware
# configuration. Also, FFDC can grow big some time so FFDC collection may
# take some time.
#
# See in user's guide for more details of command line options and adavanced features
# Product home page: https://support.lenovo.com/us/en/documents/lnvo-tcli
#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::#

../OneCli inventory getinfor --htmlreport --ffdc
