// Copyright 2016 Lenovo
;(function() {
'use strict';
var logstatus;
var interactivecheck = false;

var authactive = false;

var codstr = {
    400 : "Bad Request",
    401 : "Authentication Failed",
    500 : "Internal Server Error",
    502 : "Service Unavailable",
    503 : "Service Unavailable",
    504 : "Service Unavailable"
}

function clear_main() {
    closemain();
    CloseTerminals();
    var mn = document.getElementById('main');
    while (mn.firstChild) {
        mn.removeChild(mn.firstChild);
    }
}
function set_transition() {
    var blkout = document.getElementById("blackout");
    var logform = document.getElementById("logindialog");
    blkout.style.transition="0.5s";
    //Wait for main to be obstructed before clearing it out
    setTimeout(clear_main, 500);
}


function create_authui() {
    var blkout = document.getElementById("blackout");
    if (blkout) {
        blkout.parentElement.removeChild(blkout);
    }
    blkout = document.createElement('div');
    blkout.id = 'blackout';
    var logdlg = document.createElement('div');
    logdlg.id = 'logindialog';
    var logform = document.createElement('form');
    logform.id = 'loginform';
    var userentry = document.createElement('input');
    userentry.id = 'username';
    userentry.type = 'text';
    userentry.setAttribute('spellcheck', 'false');
    var passentry = document.createElement('input');
    passentry.type = 'password';
    passentry.id = 'password';
    var logbutton = document.createElement('button');
    logbutton.type = 'submit';
    logbutton.id = 'loginbutton'
    logbutton.textContent = l('Login');
    var logo = document.createElement('img');
    logo.setAttribute('src', 'images/branding/current/logo.svg');
    logo.style.background = '#e32124';
    var sublogo = document.createElement('img');
    sublogo.setAttribute('src', 'images/branding/current/confluentlogo.svg');
    sublogo.classList.add('conflogo');
    logstatus = document.createElement('span');
    var csrf = document.createElement('input');
    csrf.setAttribute('type', 'hidden');
    csrf.setAttribute('name', 'csrf');
    csrf.setAttribute('value', Math.random().toString(36).substr(2,16));
    logform.appendChild(csrf);
    logform.appendChild(document.createTextNode(l('Username') + ':'));
    logform.appendChild(userentry);
    logform.appendChild(document.createElement('br'));
    logform.appendChild(document.createTextNode(l('Password') + ':'));
    logform.appendChild(passentry);
    logform.appendChild(document.createElement('br'));
    logform.appendChild(logstatus);
    logform.appendChild(logbutton);
    logdlg.appendChild(logo);
    logdlg.appendChild(sublogo);
    logdlg.appendChild(logform);
    blkout.appendChild(logdlg);
    document.body.appendChild(blkout);
}

var textClearer;
function show_auth(e) {
    if (authactive) { 
        if (interactivecheck) {
            if (textClearer) {
                clearTimeout(textClearer);
            }
            var logform = document.getElementById("logindialog");
            logform.style.animationName = 'shake';
    	    logstatus.style.color = 'darkred';
            var textContent = "Authentication Failed";
            if(codstr[e] != null){
                textContent = codstr[e];
            }
            logstatus.textContent = l("Error: " + textContent);
            textClearer = setTimeout(function() {
                logstatus.textContent = '';
            }, 5000);
        }
        return;
    }
    authactive = true;
    stopAsync();
    document.body.style.overflow = 'hidden';
    create_authui();
    var logform = document.getElementById('loginform');
    logform.addEventListener("submit", check_auth);
    var blkout = document.getElementById("blackout");
    blkout.style.opacity=1;
    blkout.style.pointerEvents="auto";
    document.getElementById("username").focus();
    setTimeout(set_transition, 0);
}

function clear_auth(sessinfo) {
    if (sessinfo['authtoken']) { setAuthToken(sessinfo['authtoken']); }
    interactivecheck = false;
    authactive = false;
    document.body.style.overflow = 'visible';
    document.getElementById("banner").style.visibility = "visible";
    document.getElementById("navheader").style.visibility = "visible";
    startAsync(async_running.bind(sessinfo));
}
function async_running() {
    var sessinfo = this;
    window.noderange = defaultnoderange();
    main();
    document.getElementById("namedisplay").textContent = " " + sessinfo.username;
    var blkout = document.getElementById("blackout");
    if (blkout) {
        blkout.style.opacity = 0;
        blkout.style.pointerEvents = "none";
        blkout.parentElement.removeChild(blkout);
    }
}

function check_auth(e) {
    if (e.preventDefault) e.preventDefault();
    var logform = document.getElementById("logindialog");
    logform.style.animationName = null;
    var username = document.getElementById("username").value;
    var password = document.getElementById("password").value;
    if (password) {
        interactivecheck = true;
        logstatus.textContent = l('Checking Authentication..');
        logstatus.style.color = 'white';
        getRequest("/confluent-api/sessions/current/info", clear_auth, show_auth, username, password, true);
    } else {
        document.getElementById("password").focus();
    }
    return false;
}

function initauth() {
    getRequest("/confluent-api/sessions/current/info", clear_auth, show_auth, undefined, undefined, true);
}

function done_logout() {
    getRequest("/confluent-api/sessions/current/info", clear_auth, show_auth);
}
function logout() {
    stopAsync();
    getRequest("/confluent-api/sessions/current/logout", done_logout, done_logout);
}
window.logout = logout;
window.initauth = initauth;
window.show_auth = show_auth;
window.clear_main = clear_main;
})();
