// Copyright 2016 Lenovo
;(function() {
    'use strict';
    var nodelist = [];
    var enclist = [];
    var active = 0;
    var encpowerchart = null;
    var powerchart = null;
    var cputempchart = null;
    var cputemphisto = null;
    var powerhisto = null;
    var mainpane;
    var minpower = null;
    var maxpower = null;
    var pendingpowerupdate = null;
    var pendingtempupdate = null;

    function pad(number) {
        if (number < 10) {
            return '0' + number;
        }
        return number;
    }

    function new_chart() {
        var thechart = document.createElement('div');
        thechart.style.display = 'inline-block';
        thechart.style.width = '50%';
        thechart.style.height = (0.8 * window.innerHeight) + 'px';
        thechart.data = null;
        return thechart;
    }

    var enclosures;

    function initpowerchart() {
        nodelist = [];
        enclist = [];
        cputempchart = new_chart();
        powerchart = new_chart();
        encpowerchart = new_chart();
        //powerhisto = new_chart();
        mainpane.appendChild(cputempchart);
        mainpane.appendChild(powerchart);
        mainpane.appendChild(encpowerchart);
        //mainpane.appendChild(powerhisto);
        getRequest('/confluent-api/noderange/' + noderange + '/nodes/', updatenodelist);
        enclosures = new Object();
        getRequest('/confluent-api/noderange/' + noderange + '/attributes/current', mapenclosures);
    }

    function updatenodelist(data) {
        if (data.item) {
            var newnode = data.item.href.slice(0, -1);
            nodelist.push(newnode);
        }
        if ('_requestdone' in data) {
            updatepowerchart();
            updatecputempchart();
        }
    }

    function updateenclist(data) {
        if (data.item) {
            var newnode = data.item.href.slice(0, -1);
            enclist.push(newnode);
        }
        if ('_requestdone' in data) {
          updateencpowerchart();
        }
    }
    function mapenclosures(data) {
        if (data.databynode) {
            for (var node in data.databynode) {
                var attribd = data.databynode[node];
                if ('enclosure.manager' in attribd) {
                    enclosures[attribd['enclosure.manager'].value] = 1;
                }
            }
        }
        if ('_requestdone' in data) {
            fpcnr = Object.keys(enclosures).join(',');
            getRequest('/confluent-api/noderange/' + fpcnr + '/nodes/', updateenclist);
        }
    }

    function updateplot(plot, title, metric, min, max, data, tracenames, histo, elemlist) {
        var ncount = Object.keys(data[0]).length;
        if (ncount == 1) {
            title = elemlist[0] + ' ' + title;
        }
        if (plot.data == null) {
            var thedata = [];
            for (var md = 0; md < data.length; md++) {
                if (ncount > 1) {
                    thedata.push({
                        z: [],
                        y: [],
                        name: tracenames[md],
                        showscale: false,
                        opacity: 0.99,
                        x: elemlist,
                        type: 'surface',
                    });
                } else {
                    thedata.push({
                        y: [],
                        name: tracenames[md],
                        showscale: false,
                        opacity: 0.99,
                        x: [],
                        type: 'scatter',
                    });
                }
            }
            var layout = {
                title: title,
                scene: {
                    xaxis: {
                        title: 'Node',
                        type: 'category',
                    },
                    yaxis: {
                        title: 'Time',
                        type: 'category',
                        nticks: 4,
                    },
                }
            };
            if (ncount > 1) {
                layout.scene['zaxis'] = {
                    title: metric,
                    type: 'linear'
                };
            } else {
                layout.scene.xaxis.title = 'Time';
                layout.scene.yaxis.title = metric;
                layout.scene.yaxis.type = 'linear';
            }
        } else {
            var thedata = plot.data;
            var layout = plot.layout;
        }
        thedata[0].cmin = min;
        thedata[0].cmax = max;
        var now = new Date();
        var nextdata = [];
        for (var di = 0; di < data.length; di++) {
            nextdata = [];
            for (var idx = 0; idx < elemlist.length; idx++) {
                nextdata.push(data[di][elemlist[idx]]);
            }
            if (ncount > 1) {
                if(thedata[di].z.length >= 60){
                    thedata[di].z.shift();
                    thedata[di].y.shift();
                }
                thedata[di].z.push(nextdata);
                thedata[di].y.push(now.getHours() +
                    ":" + pad(now.getMinutes()) +
                    ":" + pad(now.getSeconds()));
            } else {
                if(thedata[di].y.length >= 60){
                    thedata[di].y.shift();
                    thedata[di].x.shift();
                }
                thedata[di].y.push(nextdata[0]);
                thedata[di].x.push(now.getHours() +
                    ":" + pad(now.getMinutes()) +
                    ":" + pad(now.getSeconds()));
            }
        }
        if (plot.data == null) {
            Plotly.newPlot(plot, thedata, layout);
            if (ncount > 1 && histo) {
                Plotly.newPlot(histo, [{
                    x: nextdata,
                    type: 'histogram',
                }], {
                    title: title,
                    scene: {
                        xaxis: {
                            title: metric,
                        },
                    },
                });
            }
        } else {
            Plotly.redraw(plot);
            if (ncount > 1 && histo) {
                histo.data[0].x = nextdata;
                Plotly.redraw(plot);
            }
        }
    }
    var curpownodes = {};

    function drawpower(data) {
        for (var nname in data['databynode']) {
            if (!data['databynode'][nname].hasOwnProperty('sensors')) {
                continue;
            }
            curpownodes[nname] = data['databynode'][nname].sensors[0].value;
            if (minpower == null) {
                minpower = data['databynode'][nname].sensors[0].value;
            }
            if (maxpower == null) {
                maxpower = data['databynode'][nname].sensors[0].value;
            }
            if (curpownodes[nname] < minpower) {
                minpower = curpownodes[nname];
            } else if (curpownodes[nname] > maxpower) {
                maxpower = curpownodes[nname];
            }
        }
        if ('_requestdone' in data) {
            updateplot(powerchart, 'Node Power Consumption', 'Power (W)', minpower, maxpower, [curpownodes], ['Power'], powerhisto, nodelist);
            curpownodes = {};
            pendingpowerupdate = setTimeout(updatepowerchart, 5000);
        }
    }

    var currcputemps = {};
    var currcpu2temps = {};
    var mincputemp = null;
    var maxcputemp = null;
    var currdcpower = {};
    var curracpower = {};
    var curracpowercap = {};

    function drawencpower(data) {
        for (var nname in data['databynode']) {
            if (!data['databynode'][nname].hasOwnProperty('sensors')) {
                continue
            }
            curracpower[nname] = data['databynode'][nname].sensors[0].value;
        }
        if ('_requestdone' in data) {
            getRequest('/confluent-api/noderange/' + fpcnr + '/sensors/hardware/all/dc_power', function(ndata) {
                for (var nname in ndata['databynode']) {
                    if (!ndata['databynode'][nname].hasOwnProperty('sensors')) {
                        continue
                    }
                    currdcpower[nname] = ndata['databynode'][nname].sensors[0].value;
                }
                if ('_requestdone' in ndata) {
                    getRequest('/confluent-api/noderange/' + fpcnr + '/sensors/hardware/all/total_power_capacity', plotencpower);
                }

            });
        }
    }

    function plotencpower(data) {
        for (var nname in data['databynode']) {
            if (!data['databynode'][nname].hasOwnProperty('sensors')) {
                continue
            }
            curracpowercap[nname] = data['databynode'][nname].sensors[0].value;
        }
        if ('_requestdone' in data) {
            updateplot(encpowerchart, 'Enclosure Power', 'Power (W)', 1, 8000, [curracpowercap, curracpower, currdcpower], ['Capacity', 'AC Power', 'DC Power'], null, enclist);
            setTimeout(updateencpowerchart, 5000);
        }

    }

    function drawtemp(data) {
        for (var nname in data['databynode']) {
            if (!data['databynode'][nname].hasOwnProperty('sensors')) {
                continue;
            }
            currcputemps[nname] = data['databynode'][nname].sensors[0].value;
            if (mincputemp == null) {
                mincputemp = data['databynode'][nname].sensors[0].value;
            }
            if (maxcputemp == null) {
                maxcputemp = data['databynode'][nname].sensors[0].value;
            }
            if (currcputemps[nname] < mincputemp) {
                mincputemp = currcputemps[nname];
            } else if (currcputemps[nname] > maxpower) {
                maxcputemp = currcputemps[nname];
            }
        }
        if ('_requestdone' in data) {
            getRequest('/confluent-api/noderange/' + noderange + '/sensors/hardware/all/cpu2_temp', plottemp);
        }
    }

    function plottemp(data) {
        for (var nname in data['databynode']) {
            if (!data['databynode'][nname].hasOwnProperty('sensors')) {
                continue;
            }
            currcpu2temps[nname] = data['databynode'][nname].sensors[0].value;
            if (mincputemp == null) {
                mincputemp = data['databynode'][nname].sensors[0].value;
            }
            if (maxcputemp == null) {
                maxcputemp = data['databynode'][nname].sensors[0].value;
            }
            if (currcpu2temps[nname] < mincputemp) {
                mincputemp = currcpu2temps[nname];
            } else if (currcpu2temps[nname] > maxcputemp) {
                maxcputemp = currcpu2temps[nname];
            }
        }
        if ('_requestdone' in data) {
            updateplot(cputempchart, 'Processor Temperature', 'Degrees (C)', mincputemp, maxcputemp, [currcputemps, currcpu2temps], ['CPU 1', 'CPU 2'], null, nodelist);
            pendingtempupdate = setTimeout(updatecputempchart, 5000);
        }
    }



    function updatepowerchart() {
        if (!active) {
            return;
        }
        curpownodes = {};
        getRequest('/confluent-api/noderange/' + noderange + '/sensors/hardware/all/avg_power', drawpower);
    }

    function updatecputempchart() {
        if (!active) {
            return;
        }
        currcputemps = {};
        getRequest('/confluent-api/noderange/' + noderange + '/sensors/hardware/all/cpu1_temp', drawtemp);
    }
    var fpcnr;

    function updateencpowerchart() {
        if (!active) {
            return;
        }
        fpcnr = Object.keys(enclosures).join(',');
        currdcpower = {};
        curracpower = {};
        curracpowercap = {};
        getRequest('/confluent-api/noderange/' + fpcnr + '/sensors/hardware/all/ac_power', drawencpower);
    }

    var nrchanger;

    function newnoderange() {
        if (nrchanger) {
            clearTimeout(nrchanger);
        }
        var nnr = this.value;
        noderange = nnr;
        nrchanger = setTimeout(function() {
            stopupdates();
            var jp = document.getElementsByClassName('js-plotly-plot');
            while (jp.length > 0) {
                jp[0].parentNode.removeChild(jp[0]);
            }
            if (isinvalidnoderange(nnr)) {
                var errlabel = document.createElement('span');
                errlabel.style.color = 'red';
                errlabel.innerText = 'Invalid noderange syntax';
                return;
            }
            initpowerchart();
        }, 1000);
    }

    function pause() {
        if (active) {
            stopupdates();
            this.textContent = l('Resume');
            active = 0;
        } else {
            active = 1;
            this.textContent = l('Pause');
            updatepowerchart();
            updatecputempchart();
        }
    }

    function maketoolbar() {
        var toolrow = document.createElement('ul');
        toolrow.classList.add('toolbar', 'header');
        toolrow.appendChild(maketoollabel(l('Noderange:')));
        var nrinput = document.createElement('input');
        nrinput.classList.add('tool');
        nrinput.addEventListener('input', newnoderange.bind(nrinput));
        nrinput.value = noderange;
        toolrow.appendChild(nrinput);
        var pausebutton = document.createElement('button');
        pausebutton.textContent = l('Pause');
        pausebutton.addEventListener('click', pause.bind(pausebutton));
        nrinput.value = noderange;
        toolrow.appendChild(pausebutton);
        return toolrow;
    }

    function stopupdates() {
        if (pendingpowerupdate != null) {
            clearTimeout(pendingpowerupdate);
            pendingpowerupdate = null;
        }
        if (pendingtempupdate != null) {
            clearTimeout(pendingtempupdate);
            pendingtempupdate = null;
        }
    }

    function resizeCharts() {
        [].forEach.call(document.getElementsByClassName('js-plotly-plot'),
            function(e) {
                e.style.height = (0.8 * window.innerHeight) + 'px';
                Plotly.Plots.resize(e);
            });
    }

    function closechartview() {
        stopupdates();
        active = 0;
        window.removeEventListener('resize', resizeCharts);
    }

    function chartview() {
        clear_main();
        active = 1;
        window.main = chartview;
        window.closemain = closechartview;
        mainpane = document.getElementById('main');
        mainpane.appendChild(maketoolbar());
        window.addEventListener('resize', resizeCharts);
        initpowerchart();
    }
    window.chartview = chartview;
    window.closechartview = closechartview;
})();
