function doPower() {
    var targets = this[0];
    var newstate = this[1];
    if (targets.includes(',')) {
        postRequest('/confluent-api/noderange/' + targets + '/power/state',
                    {state: newstate}, processPowerState);
    } else {
        postRequest('/confluent-api/nodes/' + targets + '/power/state',
                    {state: newstate}, processPowerState);
    }
}

function changePower(selectedNode, newPowerState) {  //selectedNode is optional. Not including it will affect all nodes currently displayed (original behavior)
    var targets = [];
    if (Array.isArray(selectedNode)) {
        targets = selectedNode;
    } else {
		targets.push(selectedNode);
	}
    var question = l('Do you want to change power for') + ' ' + targets.length + ' ' + l('systems?');
    if (targets.length == 1) {
        question = l('Do you want to change power for ') + targets[0] + '?';
    }
    targets = targets.join(',');
    confirmAction(question, doPower.bind([targets, newPowerState]));
}

function displayNote(json){
    var nodename = this;

    var note = json["info.note"];
    if(note != null && note != undefined){

        var noteWindow = document.createElement("div");
        document.getElementsByTagName("BODY")[0].appendChild(noteWindow);
        noteWindow.classList.add("noteDialog");
        
        var noteHeading = noteWindow.appendChild(document.createElement("span"));
        noteHeading.classList.add("noteHeader");
        noteHeading.innerHTML = "Notate " + nodename;

        var noteBreak = noteWindow.appendChild(document.createElement("span"));
        noteBreak.innerHTML = "<br/>";

        var noteText = noteWindow.appendChild(document.createElement("textarea"));
        noteText.cols = 60;
        noteText.rows = 6;
        noteText.innerHTML = note.value;

        var noteFoot = noteWindow.appendChild(document.createElement("span"));
        noteFoot.innerHTML = "<br/><br/>";
        noteSubmit = noteFoot.appendChild(document.createElement("button"));
        noteCancel = noteFoot.appendChild(document.createElement("button"));
        noteSubmit.innerHTML = "Submit";
        noteCancel.innerHTML = "Cancel";
        noteSubmit.classList.add("noteSubmit");
        noteCancel.classList.add("noteCancel");

        noteCancel.addEventListener("click", function(){
            noteWindow.parentNode.removeChild(noteWindow);
        });

        noteSubmit.addEventListener("click", function(){
            var noteVal = noteText.value;
            var data = { "info.note": noteVal };
            var url = "/confluent-api/nodes/" + nodename + "/attributes/all";
            putRequest(url, data, donull);
            noteWindow.parentNode.removeChild(noteWindow);
        });

    }
    
}

function PopRight(renderer, below) {
    var self = this;
    self.renderer = renderer;
    self.stayactive = false;
    self.below = below;
    self.createElem = function() {
        if (self.mydiv) { return; }
        self.mydiv = document.createElement('div');
        self.mydiv.classList.add('popright');
        self.renderer(self.mydiv);
    };
    self.removeElem = function() {
        if (!self.mydiv) { return; }
        self.mydiv.parentElement.removeChild(self.mydiv);
        self.mydiv = false;
    };
    self.activate = function(parent) {
        self.createElem();
        var rightMargin = window.innerWidth - parent.getBoundingClientRect().right;
        var leftMargin = parent.getBoundingClientRect().left;
        var right = true;
        if(rightMargin < 200 && leftMargin > rightMargin){
            right = false;
        }
        var bottomMargin = document.documentElement.clientHeight - parent.getBoundingClientRect().bottom;
        var down = true;
        if(bottomMargin < 225){
            down = false;
        }
        var body = document.body;
        var diff = window.outerHeight - window.innerHeight;
        if(right){
            if(down){
                if (self.below) {
                    self.mydiv.style.top = parent.getBoundingClientRect().bottom + window.pageYOffset + 'px';
                    self.mydiv.style.left = parent.getBoundingClientRect().left + window.pageXOffset + 'px';
                } else {
                    self.mydiv.style.top = parent.getBoundingClientRect().top + window.pageYOffset + 'px';
                    self.mydiv.style.left = parent.getBoundingClientRect().right + window.pageXOffset + 'px';
                }
            }else{
                if (self.below) {
                    self.mydiv.style.bottom = document.documentElement.clientHeight - parent.getBoundingClientRect().top - window.pageYOffset + 'px';
                    self.mydiv.style.left = parent.getBoundingClientRect().left + window.pageXOffset + 'px';
                } else {
                    self.mydiv.style.bottom = document.documentElement.clientHeight - parent.getBoundingClientRect().bottom - window.pageYOffset + 'px';
                    self.mydiv.style.left = parent.getBoundingClientRect().right + window.pageXOffset + 'px';
                }
            }
        }else{
            //var body = document.body;
            if(down){
                if (self.below) {
                    self.mydiv.style.top = parent.getBoundingClientRect().bottom + window.pageYOffset + 'px';
                    self.mydiv.style.right = body.clientWidth - parent.getBoundingClientRect().right - window.pageXOffset + 'px';
                } else {
                    self.mydiv.style.top = parent.getBoundingClientRect().top + window.pageYOffset + 'px';
                    self.mydiv.style.right = body.clientWidth - parent.getBoundingClientRect().left - window.pageXOffset + 'px';
                }
            }else{
                if (self.below) {
                    self.mydiv.style.bottom = document.documentElement.clientHeight - parent.getBoundingClientRect().top - window.pageYOffset + 'px';
                    self.mydiv.style.right = body.clientWidth - parent.getBoundingClientRect().right - window.pageXOffset + 'px';
                } else {
                    self.mydiv.style.bottom = document.documentElement.clientHeight - parent.getBoundingClientRect().bottom - window.pageYOffset + 'px';
                    // distance from bottom = height of inner window - distance to bottom of wrench = distance to bottom of wrench from bottom
                    self.mydiv.style.right = body.clientWidth - parent.getBoundingClientRect().left - window.pageXOffset + 'px';
                }
            }
        }
        
        document.getElementById('main').appendChild(self.mydiv);
    };
    self.ignore = function(evt) {
        evt.stopImmediatePropagation();
    };
    self.clickactivate = function(evt) {
        self.stayactive = true;
        //self.mydiv.style.borderWidth = '3px';
        self.mydiv.style.boxShadow = '0 0 10px #000000';
        this.removeEventListener('mouseleave', self.hoverdeactivate);
        this.removeEventListener('click', self.clickactivate);
        self.mydiv.addEventListener('click', self.ignore);
        document.addEventListener('click', self.deactivate);
        self.parentelem = this;
        self.activate(this);
        self.mydiv.removeEventListener('mouseleave', self.hoverdeactivate);
    };
    self.hoveractivate = function(evt) {
        self.parentelem = this;
        this.addEventListener('mouseleave', self.hoverdeactivate);
        this.removeEventListener('mouseenter', self.hoveractivate);
        self.activate(this);
        self.mydiv.addEventListener('mouseleave', self.hoverdeactivate);
    };
    self.hoverdeactivate = function(e) {
        if (e.relatedTarget == self.mydiv) {
            return;
        }
        self.mydiv.removeEventListener('mouseleave', self.hoverdeactivate);
        self.parentelem.removeEventListener('mouseleave', self.hoverdeactivate);
        self.parentelem.addEventListener('mouseenter', self.hoveractivate);
        self.removeElem();
    };
    self.deactivate = function() {
        if (self.stayactive) {
            self.stayactive = false;
            return;
        }
        self.mydiv.style.borderWidth = '1px';
        document.removeEventListener('click', self.deactivate)
        self.parentelem.addEventListener('mouseenter', self.hoveractivate);
        self.parentelem.addEventListener('click', self.clickactivate);
        self.removeElem();
    };
    return self;
}


function nodeQuickActions(icon, nodename, consolemode, below, cons) {
    var self = this;
    self.console = cons;
    self.nodename = nodename;
    self.openConsole = function(e) {
            self.nqp.deactivate();
            new TerminalWindow("/confluent-api/nodes/" + self.nodename + "/console/session", self.nodename + ' ' + l('Console'), e.clientX-220, e.clientY-5, true);
    };
    self.openShell = function(e) {
            self.nqp.deactivate();
            new TerminalWindow("/confluent-api/nodes/" + self.nodename + "/shell/sessions/", self.nodename + ' ' + l('Shell'), e.clientX-220, e.clientY-5);
    };
    self.openGui = function(e) {
            self.nqp.deactivate();
	    window.open("/confluent-api/nodes/" + self.nodename + "/forward/web");
    };
    self.changeNodePower = function(e) {
            self.nqp.deactivate();
            changePower(self.nodename, this);
    };
    self.identify = function(e) {
            self.nqp.deactivate();
            var data = { 'identify': this };
            var url = "/confluent-api/nodes/" + self.nodename + "/identify";
            postRequest(url, data, donull);
    };
    self.sendbreak = function(e) {
        self.nqp.deactivate();
        self.console.sendbreak();
        self.console.focus();
    };
    self.renderInto = function(container) {
        var rightMargin = window.innerWidth - icon.getBoundingClientRect().right;
        var leftMargin = icon.getBoundingClientRect().right;
        var dropright = 'dropright';
        if(rightMargin >= 200 && rightMargin < 550 && leftMargin > rightMargin - 300){   // main menu won't go left (>=200) but submenu needs to (< 550)
            dropright = 'dropleft';
        }else if(rightMargin < 160 && leftMargin - 300 > rightMargin){        // pops left but doesn't have room for submenus to popright
            dropright = 'dropleft';
        }
        var bottomMargin = window.innerHeight - icon.getBoundingClientRect().bottom;
        var dropdown = 'dropdown';
        //console.log(bottomMargin);
        if( bottomMargin < 50 || ( bottomMargin > 220 && bottomMargin < 270 )){  // < 50 = open up, no room for submenu. 220 - 270 = opens down & no room
            dropdown = 'dropup';
        }

        container.appendChild(document.createTextNode(self.nodename + ' ' + l('Quick Actions')));
        container.appendChild(document.createElement('hr'));
        var menu = document.createElement('ul');
        menu.classList.add('menu');
        container.appendChild(menu);
        //addMenuItem(menu, 'Identify', donull, 'lightbulb-o');
        var idmenu = addToolMenu(menu, 'Identify', 'lightbulb-o', dropright, dropdown, 'sub');
        addMenuItem(idmenu, 'Deactivate', self.identify.bind('off'));
        addMenuItem(idmenu, 'Activate', self.identify.bind('on'));
        if (consolemode) {
            addMenuItem(menu, 'Send Break', self.sendbreak, 'chain-broken');
        } else {
            addMenuItem(menu, 'Open Console', self.openConsole, 'desktop');
        }
        addMenuItem(menu, 'Open Shell', self.openShell, 'terminal');
	    addMenuItem(menu, 'Open Management Controller Web GUI', self.openGui, 'share');
        addMenuItem(menu, 'Notate', self.notate, 'pencil-square-o');
        addMenuItem(menu, 'Power Off', self.changeNodePower.bind('off'), 'power-off');
        //addMenuItem(menu, 'Boot', self.changeNodePower.bind('boot'), 'refresh');
        var bootmenu = addToolMenu(menu, 'Boot', 'refresh', dropright, dropdown, 'sub');
        //addMenuItem(bootmenu, 'Default', donull);
        addMenuItem(bootmenu, 'Boot', self.reboot);
        addMenuItem(bootmenu, 'Boot to Setup', self.bootOptions.bind('setup'));
        addMenuItem(bootmenu, 'Boot to Network', self.bootOptions.bind('network'));
        addMenuItem(bootmenu, 'Boot to Media', self.bootOptions.bind('cd'));
        addMenuItem(menu, 'Nodeview', self.nodeview, 'search');
        addMenuItem(menu, 'Edit Node', self.editNode, 'edit');
        addMenuItem(menu, 'Delete Node', self.deleteNode, 'remove');
    };
    self.bootOptions = function(e){
        var nextdevice = this;
        var data = { "bootmode": "uefi", "nextdevice": nextdevice, "persistent": "False" };
        var url = "/confluent-api/nodes/" + self.nodename + "/boot/nextdevice";
        postRequest(url, data, self.reboot);
    };
    self.reboot = function(e){
        if (e && !e.bootmode && !e.target) {
            return;
        }
        changePower(self.nodename, "boot");
    };
    self.notate = function(e){
        var url = "/confluent-api/nodes/" + self.nodename + "/attributes/all";
        getRequest(url, displayNote.bind(self.nodename));
    };
    self.nodeview = function(e){
        window.location.hash = '#nodeview:' + self.nodename;
    };
    self.editNode = function(e){
        editNodeUI(self.nodename);
    };
    self.deleteNode = function(e){
        var question = "Delete node " + self.nodename + "?";
        confirmAction(question, deleteNode.bind(self.nodename));
    };
    self.nqp = new PopRight(self.renderInto, below);   
    icon.addEventListener('mouseenter', self.nqp.hoveractivate);
    icon.addEventListener('click', self.nqp.clickactivate);
    return self;
}

function deleteNode(nodename){
    if(nodename == null || nodename == ""){
        nodename = this;
    }

    var url = "/confluent-api/nodes/" + nodename;
    deleteRequest(url, refresh);
}

function quickIcon(nodename, isconsole, below, console) {
    var quickicon = document.createElement('span');
    quickicon.classList.add('fa', 'fa-wrench', 'activeicon');
    quickicon.style.margin="0px 2px";
    quickicon.title = nodename + ' ' + l('Quick Actions');
    new nodeQuickActions(quickicon, nodename, isconsole, below, console);
    return quickicon;
}

var powerStates = {};

function processPowerState(powerdata) {
    if (!powerdata.hasOwnProperty('databynode')) {
        return;
    }
    if (!Array.isArray(powerdata.databynode)) {
        powerdata.databynode = [powerdata.databynode];
    }
    for (var i = 0; i < powerdata.databynode.length; i++) {
        var datum = powerdata.databynode[i];
        for (var nodename in datum) {
            var powerbutton = document.getElementById("power-" + nodename);
            if ('state' in datum[nodename]) {
                var newpb = document.createElement('span')
                newpb.setAttribute('title', datum[nodename].state.value);
                newpb.id = 'power-' + nodename;
                if (datum[nodename].state.value == 'off') {
                    newpb.setAttribute('class', 'fa fa-power-off powericon');
                    powerStates[nodename] = "off";
                } else {
                    newpb.setAttribute('class', 'poweron fa fa-power-off powericon');
                    powerStates[nodename] = "on";
                }
                powerbutton.parentNode.replaceChild(newpb, powerbutton);
                // ns
            //askpwrdlg = new Dialog('powerdlg-' + this.nodename);
            //makepower(askpwrdlg, data.state.value);
            //powerbutton.addEventListener('click', askpwrdlg.promptactivate);
            // end ns
            } else if ('error' in datum[nodename]) {
                newpb = document.createElement('span')
                newpb.id = 'power-' + nodename;
                newpb.setAttribute('title', datum[nodename].error);
                newpb.setAttribute('class', 'fa fa-question powericon');
                powerbutton.parentNode.replaceChild(newpb, powerbutton);
                powerStates[nodename] = "unknown";
            }
        }
    }

}

function drawnodes(url) {
  while (noderows.firstChild) {
      noderows.removeChild(noderows.firstChild);
  }
  getRequest(url, function( data) {
    nodes = [];
    noderowmap = {};
    nodehealthmap = {};
    data["_links"]["item"].forEach( function( val, key ) {
        nodes.push(val.href.replace('/', ''));
    });
    nodes.forEach(drawnode.bind(noderows));
    getchunkpower();
    getchunkhealth();
    var colwidth = maxnoderowwidth + 50;
    noderows.style.WebkitColumnWidth = colwidth + 'px';
    noderows.style.MozColumnWidth = colwidth + 'px';
    noderows.style.columnWidth = colwidth + 'px';
  }, donull, undefined, undefined, true);
}


var refreshTimeout = 0;

function refresh(){

    var hash = window.location.hash;

    if(hash == "#compactoverview" || hash == ""){

        if(refreshTimeout == 0){
            refreshTimeout = setTimeout(function(){window.location.reload(true)}, 1);
        }
    }
    
}