// Copyright 2016 Lenovo
;(function() {
'use strict';
var compactactive = false;
function partition_list(sourcelist, partitions) {
    var chunksize = Math.ceil(sourcelist.length / partitions);
    var partitioned = [];
    for (var i = 0; i < sourcelist.length; i += chunksize) {
        partitioned[partitioned.length] = sourcelist.slice(i, i + chunksize);
    }
    return partitioned;
}

function healthInfo(icon, health, nodename, healthsummary) {

    var self = this;
    self.health = health;
    self.nodename = nodename;
    self.healthsummary = healthsummary;
    self.renderInto = function (container) {
        container.appendChild(document.createTextNode(self.nodename));
        if (typeof self.health == 'string') {
            container.appendChild(document.createTextNode(': ' + self.health));
            return;
        }
        // } else {
        //     if (self.healthsummary == 'ok') {
        //         container.appendChild(document.createTextNode(': ok'));
        //         return;
        //     }
        // }
        container.appendChild(document.createElement('hr'));
        for (var i = 0; i < self.health.sensors.length; i++) {
            renderreading(container, self.health.sensors[i]);
            container.appendChild(document.createElement('br'));
        }
        if(self.health.sensors.length < 1){   // no sensor errors
            rendernoerrors(container);
            container.appendChild(document.createElement('br'));
        }
    };
    var healthdlg = new PopRight(self.renderInto);
    icon.addEventListener('mouseenter', healthdlg.hoveractivate);
    icon.addEventListener('click', healthdlg.clickactivate);
}

function rendernoerrors(container){
    var newspan = document.createElement('span');
    var healthicon = document.createElement('i');

    healthicon.setAttribute('class', 'fa fa-check green');
    newspan.appendChild(healthicon);
    var healthstr = "No errors";

    var healthnode = document.createTextNode(healthstr);
    newspan.appendChild(healthnode);
    container.appendChild(newspan);
}

function renderreading(container, reading) {
    var newspan = document.createElement('span');
    var healthicon = document.createElement('i');
    //critical.svg  failed.svg  ok.svg  unknown.svg  warning.svg
    if (reading.health == 'warning') {
        healthicon.setAttribute('class', 'fa fa-exclamation-triangle yellow');
    } else if (reading.health == 'failed'  || reading.health == 'critical') {
        healthicon.setAttribute('class', 'fa fa-times-circle red');
    } else if (reading.health == 'unknown') {
        healthicon.setAttribute('class', 'fa fa-question');
    } else if (reading.health == 'ok') {
        healthicon.setAttribute('class', 'fa fa-check green');
    }
    newspan.appendChild(healthicon);
    var healthstr = reading.name + ': ' + reading.states.join();
    if (reading.value != null) {
        healthstr += ' ' + reading.value;
    }

    var healthnode = document.createTextNode(healthstr);
    newspan.appendChild(healthnode);
    container.appendChild(newspan);
}

function makepower(dlg, currpower) {
    if (currpower == 'on') {
        valid_power = [ "shutdown", "off", "reset" ];
    } else {
        valid_power = [ "on" ];
    }
    valid_power.forEach(function(dostate) {
        newdiv = document.createElement('div');
        newdiv.appendChild(document.createTextNode(dostate));
        dlg.mydiv.appendChild(newdiv);
    });
}
var powertimeout;
var healthtimeout;
var poewrStates = {};

function processPowerState(powerdata) {
    if (!compactactive) { return; }
    if ('_requestdone' in powerdata) {
        powertimeout = setTimeout(getchunkpower, 10000);
    }
    if (!powerdata.hasOwnProperty('databynode')) {
        return;
    }
    if (!Array.isArray(powerdata.databynode)) {
        powerdata.databynode = [powerdata.databynode];
    }
    for (var i = 0; i < powerdata.databynode.length; i++) {
        var datum = powerdata.databynode[i];
        for (var nodename in datum) {
            var powerbutton = document.getElementById("power-" + nodename);
            if ('state' in datum[nodename]) {
                var newpb = document.createElement('span')
                newpb.setAttribute('title', datum[nodename].state.value);
                newpb.id = 'power-' + nodename;
                if (datum[nodename].state.value == 'off') {
                    newpb.setAttribute('class', 'fa fa-power-off powericon');
                    powerStates[nodename] = "off";
                } else {
                    newpb.setAttribute('class', 'poweron fa fa-power-off powericon');
                    powerStates[nodename] = "on";
                }
                powerbutton.parentNode.replaceChild(newpb, powerbutton);
                // ns
            //askpwrdlg = new Dialog('powerdlg-' + this.nodename);
            //makepower(askpwrdlg, data.state.value);
            //powerbutton.addEventListener('click', askpwrdlg.promptactivate);
            // end ns
            } else if ('error' in datum[nodename]) {
                newpb = document.createElement('span')
                newpb.id = 'power-' + nodename;
                newpb.setAttribute('title', datum[nodename].error);
                newpb.setAttribute('class', 'fa fa-question powericon');
                powerbutton.parentNode.replaceChild(newpb, powerbutton);
                powerStates[nodename] = "unknown";
            }
        }
    }

    var allTerms = window.allterms;

    for (var index in allTerms){      // update title of each open terminal
        var term = allTerms[index];
        var nodename = term.nodename.replace(" Console", "");
        term.mymaintab.powerstate = powerStates[nodename]; 
        term.mymaintab.gotdata();
    }
}

function filterHealth(health) {
	var allowedhealth = this;
   	if(!Array.isArray(allowedhealth)){
   		allowedhealth = health;
   	}

// adjust filter dropdown to reflect choice
    var filterChoice = "";
    if(allowedhealth.indexOf("ok")>-1){  // choice = all
    	filterChoice = "All";
    	document.getElementById("All").classList.add("selected");
    	document.getElementById("Warning").classList.remove("selected");
    	document.getElementById("Critical").classList.remove("selected");
    }else if(allowedhealth.indexOf("warning")>-1){  // choice = warning
    	filterChoice = "Warning";
    	document.getElementById("All").classList.remove("selected");
    	document.getElementById("Warning").classList.add("selected");
    	document.getElementById("Critical").classList.remove("selected");
    }else if(allowedhealth.indexOf("critical")>-1){  // choice = critical
    	filterChoice = "Critical";
    	document.getElementById("All").classList.remove("selected");
    	document.getElementById("Warning").classList.remove("selected");
    	document.getElementById("Critical").classList.add("selected");
    }

// change text
    var filterText = " Filter by Health";
    if(filterChoice != ""){
    	filterText += " - " + filterChoice;
    }

    var filterNodes = document.getElementById("Filter_by_health").childNodes;
    [].forEach.call(filterNodes, function(node){
    	if(node.nodeType == 3){
    		node.textContent = filterText;
    	}
    });

// actually filter
    for (var nodename in nodehealthmap) {
        if (allowedhealth.indexOf(nodehealthmap[nodename]) > -1) {
            noderowmap[nodename].style.display = 'block';
        } else {
            noderowmap[nodename].style.display = 'none';
        }
    }

}

function processHealth(healthdata) {
    var healthbynode = {};
    var healthsum;
    if (!compactactive) { return; }
    if ('_requestdone' in healthdata) {
        healthtimeout = setTimeout(getchunkhealth, 30000);
    }
    if (!healthdata.hasOwnProperty('databynode')) {
        return;
    }
    if (!Array.isArray(healthdata.databynode)) {
        healthdata.databynode = [healthdata.databynode];
    }
    for (var i = 0; i < healthdata.databynode.length; i ++) {
        var datum = healthdata.databynode[i];
        for (var nodename in datum) {
            if ('health' in datum[nodename]) {
                var newhealthstat = document.createElement('span')
                nodehealthmap[nodename] = datum[nodename].health.value;
                if (datum[nodename].health.value == 'warning') {
                    newhealthstat.setAttribute('class', 'fa fa-exclamation-triangle yellow icon');
                } else if (datum[nodename].health.value == 'critical' || datum[nodename].health.value == 'failed') {
                    newhealthstat.setAttribute('class', 'fa fa-times-circle red icon');
                } else if (datum[nodename].health.value == 'unknown') {
                    newhealthstat.setAttribute('class', 'fa fa-question red icon');
                } else if (datum[nodename].health.value == 'ok') {
                    newhealthstat.setAttribute('class', 'fa fa-check green icon');
                } else {
                    newhealthstat.setAttribute('class', 'fa fa-question icon');
                }

                healthsum = document.getElementById("health-"+nodename);
                healthsum.parentNode.replaceChild(newhealthstat, healthsum);
                newhealthstat.setAttribute('id', "health-"+nodename);
                healthbynode[nodename] = datum[nodename].health.value;
            } else if ('sensors' in datum[nodename]) {
                healthsum = document.getElementById("health-"+nodename);
                var healthinfo = new healthInfo(healthsum, datum[nodename], nodename, healthbynode[nodename]);  //last argument always undefined
            } else if ('error' in datum[nodename]) {
                newhealthstat = document.createElement('span')
                newhealthstat.setAttribute('class', 'fa fa-question icon red');
                newhealthstat.setAttribute('title', 'Health not known: ' + datum[nodename].error);
                healthsum = document.getElementById("health-"+nodename)
                newhealthstat.setAttribute('id', "health-"+nodename);
                healthsum.parentNode.replaceChild(newhealthstat, healthsum);
                healthinfo = new healthInfo(newhealthstat, 'Health not known: ' + datum[nodename].error, nodename);
            }
        }
    }
}

function getchunkpower() {
    if (noderange == "") { return; }
    powertimeout = null;
    getRequest("/confluent-api/noderange/" + noderange + "/power/state", processPowerState);
}

function getchunkhealth() {
    if (noderange == "") { return; }
    healthtimeout = null;
    getRequest("/confluent-api/noderange/" + noderange + "/health/hardware", processHealth);
}

var maxnoderowwidth = 0;
var noderowmap;
var nodehealthmap;
function drawnode(nodename, key) {
    var myrow = document.createElement('div');
    myrow.style.display = 'block';
    noderowmap[nodename] = myrow;
    myrow.classList.add('noderow');
    var healthspan = document.createElement('span')
    healthspan.classList.add('icon', 'fa', 'fa-spinner', 'fa-spin');
    healthspan.id = 'health-' + nodename;
    var nodenamespan = document.createElement('span');
    nodenamespan.classList.add('nodename');
    nodenamespan.textContent = nodename;
    nodenamespan.addEventListener('click', function() { window.location.hash = '#nodeview:'+nodename });
    var powerspan = document.createElement('span');
    powerspan.id='power-' + nodename;
    powerspan.classList.add('fa', 'fa-spinner', 'fa-spin', 'powericon');
    var quickicon = quickIcon(nodename);
    myrow.appendChild(healthspan);
    myrow.appendChild(powerspan);
    myrow.appendChild(quickicon);
    myrow.appendChild(nodenamespan);
    this.appendChild(myrow);
    var mywidth = healthspan.offsetWidth + powerspan.offsetWidth + nodenamespan.offsetWidth + quickicon.offsetWidth;
    if (mywidth > maxnoderowwidth) {
        maxnoderowwidth = mywidth;
    }
//    document.getElementById("console-"+nodename).addEventListener("click", nodecontext.openconsole.bind(nodecontext));
}

function createSelection(options) {
    var ms = document.createElement('select');
    options.forEach(function(o) {
        var opt = new Option(o, o);
        ms.appendChild(opt);
    });
    return ms;
}

var bkitem;
function globalPower() {
    var targets = [];
    for (var node in noderowmap) {
       if (noderowmap[node].style.display == 'block') {
            targets.push(node);
        }
    }
    changePower(targets, this);
}
function maketoolbar() {
    var toolrow = document.createElement('ul');
    toolrow.classList.add('toolbar', 'header');
    /*
    toolrow.appendChild(maketoollabel(l('Select') + ":"));
    var selections = createSelection(['', 'All', 'None', 'Invert']);
    selections.classList.add('tool');
    toolrow.appendChild(maketoollabel(l('Next Boot') + ":"));
    selections = createSelection(['', 'default', 'network', 'cd', 'disk']);
    selections.classList.add('tool');
    toolrow.appendChild(selections);
    */
    var healthmenu = addToolMenu(toolrow, 'Filter by health', 'medkit');
    addMenuItem(healthmenu, 'Critical', filterHealth.bind(['critical', 'failed']), 'times-circle');
    addMenuItem(healthmenu, 'Warning', filterHealth.bind(['warning', 'critical', 'failed']), 'exclamation-triangle');
    addMenuItem(healthmenu, 'All', filterHealth.bind(['ok', 'warning', 'critical', 'failed']), 'check-square');
    var powerMenu = addToolMenu(toolrow, 'Power', 'power-off'); 
    addMenuItem(powerMenu, 'Off', globalPower.bind('off'), 'power-off');
    addMenuItem(powerMenu, 'Boot', globalPower.bind('boot'), 'refresh');
    addMenuItem(powerMenu, 'Shutdown', globalPower.bind('shutdown'), 'power-off');
    toolrow.appendChild(maketoollabel(l('Noderange:')));
    var nrinput = document.createElement('input');
    nrinput.value = noderange;
    nrinput.classList.add('tool');
    nrinput.addEventListener('input', newnoderange.bind(nrinput));
    toolrow.appendChild(nrinput);
    var terms = addToolMenu(toolrow, 'Terminals', 'desktop', 'dropright', 'dropdown', 'main');
    terms.id = "terminalMenuContent";
    addMenuItem(terms, 'Open Multiple Consoles', openAllTerms.bind('/console/session'), 'desktop');
    addMenuItem(terms, 'Open Multiple Shells', openAllTerms.bind('/shell/sessions/'), 'terminal');
    addMenuItem(terms, 'Close All Terminals', CloseTerminals, 'close');
    addMenuItem(terms, 'Arrange', TileTerminals, 'th', true);
    var resize = function() { ScaleTerminals(this); }
    addMenuItem(terms, 'Shrink', resize.bind(0.8), 'minus-square', true);
    addMenuItem(terms, 'Reset Size', resize.bind(1), 'square', true);
    addMenuItem(terms, 'Enlarge', resize.bind(1.2), 'plus-square', true);
    var termsPerRow = localStorage.getItem('termsperrow');
    addMenuItem(terms, 'Fit To Screen', function(){fitToScreen(localStorage.getItem('termsperrow'));}, 'external-link', true);
    //addMenuItem(terms, 'Type Everywhere', toggleBroadcast, 'keyboard-o');
    bkitem = addMenuItem(toolrow, 'Type in all Terminals', toggleBroadcast, 'keyboard-o');
    bkitem.classList.add('navitem');


    return toolrow;
}

var nrchanger;

function newnoderange() {
    if (nrchanger) {
        clearTimeout(nrchanger)
    }
    var nnr = this.value;
    noderange = nnr;
    nrchanger = setTimeout(function() {
       while (noderows.firstChild) {
          noderows.removeChild(noderows.firstChild);
        }
        if (nnr == '' || isinvalidnoderange(nnr)) {
            var errlabel = document.createElement('span');
            errlabel.style.color = 'red';
            errlabel.innerText = 'Invalid noderange syntax';
            noderows.appendChild(errlabel);
            noderows.style.columnWidth = '';
            return;
        }
        drawnodes("/confluent-api/noderange/"+nnr+"/nodes/");
        nrchanger = undefined;
        }, 750);
}
var nodes = [];

var broadcasting;
function broadcastOff(e) {
    if (e && e.target.id == "Type_in_all_Terminals") { return true; }
    document.removeEventListener('keypress', AllTermsKeypress);
    document.removeEventListener('keydown', AllTermsKeydown);
    document.removeEventListener('mousedown', broadcastOff);
    broadcasting = false;
   syncBroadcastStyle();
}
function toggleBroadcast() {
   if (broadcasting) {
    broadcastOff();
   } else {
    document.addEventListener('keypress', AllTermsKeypress);
    document.addEventListener('keydown', AllTermsKeydown);
    document.addEventListener('mousedown', broadcastOff);
    broadcasting = true;
   }
   syncBroadcastStyle();
}
function syncBroadcastStyle() {
   if (broadcasting) {
    [].forEach.call(document.getElementsByClassName('bar'), function(bar){
      bar.classList.add('focused');
    });
    if (bkitem) { bkitem.style.background = 'green'; }
   } else {
    [].forEach.call(document.getElementsByClassName('bar'), function(bar){
      bar.classList.remove('focused');
    });
    if (bkitem) { bkitem.style.background = '#ffffff'; }
  }
}
window.broadcastOff = broadcastOff;

function openAllTerms() {
   var qmenu;
   var suburl = this;

   	if(suburl == '/console/session'){ // console -- need to nag
   		// nag
	   	var nagged = localStorage.getItem('consolenagged');
	    if (nagged === null){
	      confirmAction('Console output by default is logged. Take care to not use the console to type secure data in a manner that would be echoed on the terminal and thus logged. For example, using a utility that takes a password as a command argument. \n\nIf this is not desired, logging may be disabled from command line using: \n\nconfetty set /nodegroups/everything/attributes/current console.logging=none \n\nDo you acknowledge this warning and wish to continue?', openAllConsoles);
	   	}else{
	   		openAllConsoles();
	   	}
	}else{  // shells, not console -- no nag needed
		openAllShells();
	}

    // update power states
    getchunkpower();
}

function openAllConsoles(){
	localStorage.setItem('consolenagged', 'yes');
   nodes.forEach(function (node) {
        new TerminalWindow("/confluent-api/nodes/" + node + "/console/session", node + ' ' + l('Console'), undefined, undefined, quickIcon(node, true, true));
   });
   TileTerminals();
}

function openAllShells(){
	nodes.forEach(function (node) {
		new TerminalWindow("/confluent-api/nodes/" + node + "/shell/sessions/", node + ' ' + l('Shell'));
	});
	TileTerminals();
}

var noderows;

function drawnodes(url) {
  while (noderows.firstChild) {
      noderows.removeChild(noderows.firstChild);
  }
  getRequest(url, function( data) {
    nodes = [];
    noderowmap = {};
    nodehealthmap = {};
    data["_links"]["item"].forEach( function( val, key ) {
        nodes.push(val.href.replace('/', ''));
    });
    nodes.forEach(drawnode.bind(noderows));
    getchunkpower();
    getchunkhealth();
    var colwidth = maxnoderowwidth + 50;
    noderows.style.WebkitColumnWidth = colwidth + 'px';
    noderows.style.MozColumnWidth = colwidth + 'px';
    noderows.style.columnWidth = colwidth + 'px';
  }, function(errcode, errmsg) {
	  if (errcode == 404) {
		  var errlabel = document.createElement('span');
		   noderows.appendChild(errlabel);
		   errlabel.style.color = 'red';
		   errlabel.innerText = errmsg;
		   noderows.style.columnWidth = '';
	}
  }, undefined, undefined, true);
}


function adjustTermMenu(){
    var termMenuContent = document.getElementById("terminalMenuContent");
    if(termMenuContent != null){
        var termMenu = termMenuContent.parentNode;

        var rightMargin = window.innerWidth - termMenu.getBoundingClientRect().right;
        var leftMargin = termMenu.getBoundingClientRect().left;
        var right = true;
        if(rightMargin < 100 && leftMargin > rightMargin){
            right = false;
        }

        if(right){
            termMenu.classList.remove("dropleftmenu");
            termMenu.classList.add("droprightmenu");
        }else{
            termMenu.classList.remove("droprightmenu");
            termMenu.classList.add("dropleftmenu");
        }
    }
}

function closecompactoverview() {
    compactactive = false;
    if (powertimeout) {
        clearTimeout(powertimeout);
        powertimeout = null;
    }
    if (healthtimeout) {
        clearTimeout(healthtimeout);
        healthtimeout = null;
    }
}

function compactoverview() {
  clear_main();
  compactactive = true;
  window.main = compactoverview;
  window.closemain = closecompactoverview;
  var mainpane = document.getElementById('main');
  mainpane.appendChild(maketoolbar());
  noderows = document.createElement('div');
  noderows.classList.add('header');
  mainpane.appendChild(noderows);

  document.body.style = "";

  if(window.innerWidth < 540){                  // add scrollbar if it gets too small to prevent jumping quick-actions menus
    document.body.classList.remove("overflowHidden");
    document.body.classList.add("overflowScroll");
  }else{
    document.body.classList.remove("overflowScroll");
    document.body.classList.add("overflowHidden");
  }

  window.addEventListener('resize', function(){    // add scrollbar if it gets too small to prevent jumping quick-actions menus
    if(window.innerWidth < 540){
        document.body.classList.remove("overflowHidden");
        document.body.classList.add("overflowScroll");
    }else{
        document.body.classList.remove("overflowScroll");
        document.body.classList.add("overflowHidden");
    }

    adjustTermMenu();   // adjust if term menu opens right or left
  });

  drawnodes("/confluent-api/noderange/"+noderange+"/nodes/");

  filterHealth(['ok', 'warning', 'critical', 'failed']);

  // move terminal menu if needed
    adjustTermMenu();  
}
window.compactoverview = compactoverview;
window.closecompactoverview = closecompactoverview;
})();

