// Copyright 2016 Lenovo
;(function() {
'use strict';

var settings = {
    termsize: {
        defvalue: '100x31',
        label: 'Default Terminal Size',
    },
    termfontfactor: {
        defvalue: '100',
        label: 'Default Terminal Font scale percentage',
    },
    termsperrow: {
        defvalue: '10',
        label: 'Fit-To-Screen Max Terminals Per Row'
    },
    defnoderange: {
        defvalue: null,
        label: 'Default noderange selection',
    },
    nodesperpage: {
        defvalue: null,
        label: 'Default number of nodes to show at once',
    }
};

function savesettings() {
    var uidlg = this;
    var iputs = uidlg.getElementsByTagName('input');
    for (var i=0; i < iputs.length; i++) {
        localStorage.setItem(iputs[i].id, iputs[i].value);
    }
}

function configUi() {
    var uidlg = document.createElement('div');
    uidlg.classList.add('modaldialog');

    var heading = uidlg.appendChild(document.createElement("span"));
    heading.classList.add("noteHeader");
    heading.innerHTML = "User Interface";

    var headBreak = uidlg.appendChild(document.createElement("span"));
    headBreak.innerHTML = "<br/>";

    for (var setting in settings) {
        var curval = localStorage.getItem(setting);
        if (curval === null) {
            curval = settings[setting].defvalue;
        }
        var curinput = document.createElement('input');
        curinput.id = setting;
        if (curval !== null) {
            curinput.value = curval;
        }
        var thelab = document.createElement('label');
        thelab.setAttribute('for', setting);
        thelab.textContent = l(settings[setting].label) + ':';
        uidlg.appendChild(thelab);
        uidlg.appendChild(curinput);
        uidlg.appendChild(document.createElement('br'));
    }
    var bg = document.createElement('div');
    bg.classList.add('modalbg');
    document.body.appendChild(bg);
    bg.appendChild(uidlg);
    uidlg.appendChild(document.createElement('hr'));
    var save = document.createElement('button');
    save.textContent = l('Save');
    save.addEventListener('click', closeDialog.bind([uidlg, bg, savesettings.bind(uidlg)]));
    uidlg.appendChild(save);
    var cancelbtn = document.createElement('button');
    cancelbtn.textContent = l('Cancel');
    cancelbtn.addEventListener('click', closeDialog.bind([uidlg, bg, false]));
    uidlg.appendChild(cancelbtn);
}

function defaultnoderange() {
    var nr = localStorage.getItem('defnoderange');
    var num = localStorage.getItem('nodesperpage');
    var ret;
    if (nr === null) {
        ret = 'everything';
    } else {
        ret = nr;
    }
    if (!num) {
        return ret;
    }
    return ret + '>' + num;
}
window.defaultnoderange = defaultnoderange;

window.configUi = configUi;
})();

